#
# This file is provided under a dual BSD/GPLv2 license.  When using or
# redistributing this file, you may do so under either license.
#
# GPL LICENSE SUMMARY
#
# Copyright(c) 2017-2018 Intel Corporation.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of version 2 of the GNU General Public License as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# Contact Information:
# email: cas_community@intel.com
# www:   www.intel.com/cas
#
# BSD LICENSE
#
# Copyright(c) 2017-2018 Intel Corporation.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#   * Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   * Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in
#     the documentation and/or other materials provided with the
#     distribution.
#   * Neither the name of Intel Corporation nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#norootforbuild


%define kernel_flavor default
%define kernel_source /usr/src/linux-obj/x86_64/%{kernel_flavor}/
%define kernel_name %{expand:%(cd %kernel_source && make kernelrelease)}
%define kernel_version %{expand:%(kname="%{kernel_name}"; echo "${kname%%-*}")}
%define kernel_version_sufix k%{expand:%(echo %{kernel_version} | sed -r 'y/-/_/;')}

Name: Intel-CAS-kmp-%{kernel_flavor}
License: GPL-2.0 or BSD-3-Clause
BuildRequires: %kernel_module_package_buildreqs
BuildRequires: systemd
BuildRequires: sles-release
BuildRequires: udev
BuildRequires: python
Requires: systemd
Requires: udev
Requires: python
Requires: coreutils
Requires: grep
URL: https://www.intel.com/cas
Group: System/Kernel
Summary: Intel(R) CAS Version: 03.05.01.01110009
Version: 03.05.01.01110009_%{kernel_version_sufix}
Provides: Intel-CAS-kmp = 03.05.01.01110009
Provides: Intel-CAS-kmp = %version
Source0: Intel-CAS-03.05.01.01110009.tar.bz2
Source1: Intel_Cache_Acceleration_Software_for_Linux_v3.5.1_GA_AdminGuide.pdf
Source2: Intel_Cache_Acceleration_Software_for_Linux_v3.5.1_GA_RelNotes.pdf
BuildRoot: %{_tmppath}/%{name}-%{version}-build
Release: 1.1

%description
Intel(R)  CAS  accelerates Linux applications by caching active (hot) data to a local flash device inside servers. Please ensure that you review the Release Notes and Admin Guide prior to using CAS in your environment especially with Ceph and SDS solutions.
Release notes: https://drivers.suse.com/intel/Intel-CAS/sle-12-sp2-x86_64/1.0/doc/Intel_Cache_Acceleration_Software_for_Linux_v3.5.1_GA_RelNotes.pdf
For information regarging security incidents see documents in online doc directory:
https://drivers.suse.com/intel/Intel-CAS/sle-12-sp2-x86_64/1.0/doc/

%prep
%setup -n Intel-CAS-03.05.01.01110009
set -- *
mkdir src
mv sources src/
# Tag modules as SolidDriver so no need to set allow_unsupported_modules
echo "intelcas.ko external" > src/sources/kcas/Module.supported
echo "inteldisk.ko external" >> src/sources/kcas/Module.supported
mkdir obj

%build
rm -rf obj/%{kernel_flavor}
cp -r src obj/%{kernel_flavor}
EXTRA_LDFLAGS="-z noexecstack -z relro -z now -pie"
pushd obj/%{kernel_flavor}/sources/kcas
make %{?jobs:-j%jobs}
popd
pushd obj/%{kernel_flavor}/sources
make %{?jobs:-j%jobs} NO_VALIDATED_CONF_CHECK=1
popd

%install
#install kernel modules
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=updates
make -C %{kernel_source} modules_install M=$PWD/obj/%{kernel_flavor}/sources/kcas/

#install userspace pieces
install -m 755 -d %{buildroot}/sbin
install -m 755 obj/%{kernel_flavor}/sources/casadm %{buildroot}/sbin/casadm

install -m 755 -d %{buildroot}/lib/intelcas/
install -m 644 icas.py %{buildroot}/lib/intelcas/icas.py
install -m 755 intelcas %{buildroot}/lib/intelcas/intelcas
install -m 755 intelcas-loader %{buildroot}/lib/intelcas/intelcas-loader
install -m 755 intelcas-mount-utility %{buildroot}/lib/intelcas/intelcas-mount-utility

# create precompiled python files
%py_compile %{buildroot}/lib/intelcas
%py_compile -O %{buildroot}/lib/intelcas

ln -s ../lib/intelcas/intelcas %{buildroot}/sbin/intelcas

install -m 755 -d %{buildroot}/etc/intelcas
install -m 644 config/intelcas.conf %{buildroot}/etc/intelcas/intelcas.conf
install -m 444 ioclass-config.csv %{buildroot}/etc/intelcas/ioclass-config.csv

install -m 755 -d %{buildroot}/usr/lib/systemd/system
install -m 644 intelcas-shutdown.service %{buildroot}/usr/lib/systemd/system/intelcas-shutdown.service

install -m 755 -d %{buildroot}%{_udevrulesdir}
install -m 644 60-persistent-storage-intelcas-load.rules %{buildroot}/%{_udevrulesdir}/60-persistent-storage-intelcas-load.rules
%if 0%{?suse_version} == 1315
# SLE 12
install -m 644 60-persistent-storage-intelcas.rules %{buildroot}/%{_udevrulesdir}/60-persistent-storage-intelcas.rules
%endif

install -m 755 -d %{buildroot}/usr/share/man/man8
install -m 644 casadm.8.gz %{buildroot}/usr/share/man/man8/casadm.8.gz
install -m 644 intelcas.8.gz %{buildroot}/usr/share/man/man8/intelcas.8.gz
install -m 755 -d %{buildroot}/usr/share/man/man5
install -m 644 intelcas.conf.5.gz %{buildroot}/usr/share/man/man5/intelcas.conf.5.gz

install -m 755 -d %{buildroot}/%_docdir/%name
install -m 644 %{SOURCE1} %{buildroot}/%_docdir/%name/Intel_Cache_Acceleration_Software_for_Linux_v3.5.1_GA_AdminGuide.pdf
install -m 644 %{SOURCE2} %{buildroot}/%_docdir/%name/Intel_Cache_Acceleration_Software_for_Linux_v3.5.1_GA_RelNotes.pdf

install -m 755 -d %{buildroot}/usr/sbin

install -m 755 -d  %{buildroot}/lib/modules/%{kernel_name}/updates/
install -m 755 -d  %{buildroot}/lib/modules/%{kernel_name}/updates/intelcas
install -m 755 -d  %{buildroot}/lib/modules/%{kernel_name}/updates/inteldisk
install -m 644 obj/%{kernel_flavor}/sources/kcas/inteldisk/inteldisk.ko  %{buildroot}/lib/modules/%{kernel_name}/updates/inteldisk/inteldisk.ko
install -m 644 obj/%{kernel_flavor}/sources/kcas/intelcas/intelcas.ko  %{buildroot}/lib/modules/%{kernel_name}/updates/intelcas/intelcas.ko

# add symlink required by suse-missing-rclink package check
ln -s ../../usr/lib/systemd/system/intelcas-shutdown.service %{buildroot}/usr/sbin/rcintelcas-shutdown

%define cas_scripts()                                                                               \
                                                                                                    \
# check if upgrade in flight is in progress                                                         \
UPGRADE_IN_FLIGHT=0                                                                                 \
if [ -f /sys/module/inteldisk/parameters/upgrade_in_progress ] &&                                   \
   [ "$(cat /sys/module/inteldisk/parameters/upgrade_in_progress)" == "1" ]; then                   \
        # allow uninstall with running caches in case of upgrade in flight                          \
        UPGRADE_IN_FLIGHT=1                                                                         \
fi                                                                                                  \
                                                                                                    \
function get_running_devices                                                                        \
{                                                                                                   \
python -c "#                                                                                        \
import sys                                                                                          \
sys.path.append('/lib/intelcas/')                                                                   \
import icas                                                                                         \
for dev in icas.get_caches_list():                                                                  \
        print(dev['disk'])                                                                          \
"                                                                                                   \
}                                                                                                   \
                                                                                                    \
function check_cas_devices                                                                          \
{                                                                                                   \
    local NUM_DEVICES=$( get_running_devices 2>/dev/null | wc -l  )                                 \
    if [ $? -ne 0 ]; then                                                                           \
        echo ""                                                                                     \
        echo "WARNING Failed to query running caches."                                              \
        return 0;                                                                                   \
    fi                                                                                              \
    if [ $NUM_DEVICES -gt 0 ]; then                                                                 \
        echo ""                                                                                     \
        echo "ERROR: there are Intel(R) CAS cache instances running, unable to proceed "            \
        echo "with operation. Please flush and close all Intel(R) CAS devices with "                \
        echo "'intelcas stop --flush' and try again."                                               \
        echo "Ignoring this error may result in losing access to unflushed data stored on cache "   \
        echo "device."                                                                              \
        exit 1                                                                                      \
    fi                                                                                              \
}                                                                                                   \
                                                                                                    \
function get_dirty_devices                                                                          \
{                                                                                                   \
python -c "#                                                                                        \
import sys                                                                                          \
sys.path.append('/lib/intelcas/')                                                                   \
import icas                                                                                         \
config = icas.cas_config('/etc/intelcas/intelcas.conf')                                             \
for cache in config.caches.values():                                                                \
        status = icas.check_cache_device(cache.device)                                              \
        if status['Is cache'] == 'yes' and status['Cache dirty'] == 'yes':                          \
                print(cache.device)                                                                 \
"                                                                                                   \
}                                                                                                   \
                                                                                                    \
function check_dirty_data                                                                           \
{                                                                                                   \
    if [ ! -f /etc/intelcas/intelcas.conf ]; then                                                   \
        return 0                                                                                    \
    fi                                                                                              \
    # Ignoring modprobe error - SLES build system runs this code in sanboxed env to smoke test      \
    # rpm. In the sandbox 'modprobe intelcas' fails, returning error would break the build.         \
    if ! modprobe intelcas &>/dev/null; then                                                        \
        echo ""                                                                                     \
        echo "WARNING Failed to probe cache devices for dirty data (modprobe failed)."              \
        return 0                                                                                    \
    fi                                                                                              \
    OUTPUT=$( get_dirty_devices 2>/dev/null )                                                       \
    if [ $? -ne 0 ]; then                                                                           \
        echo ""                                                                                     \
        echo "WARNING Failed to probe cache devices for dirty data."                                \
        return 0                                                                                    \
    fi                                                                                              \
    if [ "$OUTPUT" != "" ]; then                                                                    \
        echo ""                                                                                     \
        echo "ERROR: following devices listed in configuration file contain dirty data:"            \
        echo "$OUTPUT"                                                                              \
        echo "Please flush and close all dirty data stored on Intel(R) CAS cache devices "          \
        echo "and try again. You can do this by running:"                                           \
        echo "'intelcas start; intelcas stop --flush'. "                                            \
        echo "Ignoring this error may result in losing access to unflushed data stored on cache "   \
        echo "device. "                                                                             \
        echo "In order to skip this check remove caches from configuration file "                   \
        echo "/etc/intelcas/intelcas.conf."                                                         \
        exit 1                                                                                      \
    fi                                                                                              \
}                                                                                                   \
                                                                                                    \
function check_preconditions                                                                        \
{                                                                                                   \
    # Don't allow to uninstall CAS when cache is running - user needs to                            \
    # manually flush data and stop caches before uinstalling or upgrading                           \
    # RPM to new version                                                                            \
    check_cas_devices                                                                               \
                                                                                                    \
    # Leaving dirty data behind may render it inaccessible, leaving primary storage                 \
    # device with outdated version of data.                                                         \
    check_dirty_data                                                                                \
}                                                                                                   \
                                                                                                    \
function unload_modules                                                                             \
{                                                                                                   \
    if lsmod 2>/dev/null | grep intelcas >/dev/null; then                                           \
        modprobe -r intelcas  2>&1 >/dev/null ||                                                    \
        {                                                                                           \
            echo "Failed to unload intelcas";                                                       \
            exit 1;                                                                                 \
        }                                                                                           \
        modprobe -r inteldisk 2>&1 >/dev/null ||                                                    \
        {                                                                                           \
            echo "Failed to unload inteldisk";                                                      \
            exit 1;                                                                                 \
        }                                                                                           \
    fi                                                                                              \
}                                                                                                   \


%pre
%cas_scripts

# before fresh install check for other CAS installation (e.g. enterprise installer)
if [ $1 -eq 1 ] && casadm -V &>/dev/null; then
    echo ""
    echo "ERROR: non-packaged Intel(R) CAS installation detected. Please remove existing installation and try again."
    exit 1
fi

# before upgrade check if caches are running
if [ $1 -gt 1 ]; then
    check_preconditions
    unload_modules
fi
%service_add_pre intelcas-shutdown.service

%post
/usr/lib/module-init-tools/weak-modules2 --add-kmp %name-%version-%release
# register systemd unit for CAS shutdown
%service_add_post intelcas-shutdown.service
if [ $1 -eq 1 ]; then
    echo "Enabling Intel(R) CAS shutdown unit"
    systemctl enable intelcas-shutdown
fi
modprobe intelcas &>/dev/null || true

%preun
%cas_scripts
# before uninstalling CAS check if caches are running
if [ $1 -eq 0 ] && [ $UPGRADE_IN_FLIGHT -ne 1 ]; then
    check_preconditions
    unload_modules
fi

%service_del_preun intelcas-shutdown.service

%postun
/usr/lib/module-init-tools/weak-modules2  --remove-kmp %name-%version-%release <<< \
"/lib/modules/%{kernel_name}/updates/intelcas/intelcas.ko
/lib/modules/%{kernel_name}/updates/inteldisk/inteldisk.ko"

%service_del_postun intelcas-shutdown.service

%files
%defattr(-,root,root)
/sbin/casadm
/sbin/intelcas
/etc/intelcas/
/lib/intelcas
/lib/intelcas/icas.py
/lib/intelcas/icas.pyc
/lib/intelcas/icas.pyo
/usr/lib/systemd/system/intelcas-shutdown.service
%{_udevrulesdir}/60-persistent-storage-intelcas-load.rules
%if 0%{?suse_version} == 1315
# SLE 12
%{_udevrulesdir}/60-persistent-storage-intelcas.rules
%endif
/usr/share/man/man8/casadm.8.gz
/usr/share/man/man8/intelcas.8.gz
/usr/share/man/man5/intelcas.conf.5.gz
/usr/sbin/rcintelcas-shutdown
%config(noreplace) /etc/intelcas/intelcas.conf
%config(noreplace) /etc/intelcas/ioclass-config.csv
%doc /%_docdir/%name/
%doc /%_docdir/%name/Intel_Cache_Acceleration_Software_for_Linux_v3.5.1_GA_AdminGuide.pdf
%doc /%_docdir/%name/Intel_Cache_Acceleration_Software_for_Linux_v3.5.1_GA_RelNotes.pdf
/lib/modules/%{kernel_name}/updates/
/lib/modules/%{kernel_name}/updates/intelcas/
/lib/modules/%{kernel_name}/updates/inteldisk/
/lib/modules/%{kernel_name}/updates/inteldisk/inteldisk.ko
/lib/modules/%{kernel_name}/updates/intelcas/intelcas.ko
%changelog
* Mon Feb 26 2018 andavis@suse.com
- Initial SolidDriver build of version 03.05.01.01110009
